<?php
/*
# ------------------------------------------------------------------------
# JA Google Translate plugin for Joomla 1.6.x
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
# ------------------------------------------------------------------------
*/ 

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
//Refer: http://code.google.com/apis/ajaxlanguage/documentation/

class plgContentJAGoogleTranslate extends JPlugin
{
	var $countId = 0;
	var $aLangSelect = array();
	var $aException = array();
	var $blockLang = '';
	
	function plgContentJAGoogleTranslate( &$subject, $config )
	{
			
		parent::__construct( $subject, $config );
		
		if ( JFactory::getApplication()->isAdmin() ) { 
			return; 
		}

		$this->plugin = &JPluginHelper::getPlugin('content', 'jagoogletranslate');
		
		$this->plgParams = new JRegistry;
		$this->plgParams->loadJSON($this->plugin->params);
		
		$this->plgUrl = JURI::Root(true) . '/plugins/'.$this->plugin->type.'/'.$this->plugin->name.'/';
		
		$this->aLangSupport = array(
			"af" => "AFRIKAANS",
			"sq" => "ALBANIAN",
			"ar" => "ARABIC",
			"be" => "BELARUSIAN",
			"bg" => "BULGARIAN",
			"ca" => "CATALAN",
			"zh" => "CHINESE",
			"zh-CN" => "CHINESE SIMPLIFIED",
			"zh-TW" => "CHINESE TRADITIONAL",
			"hr" => "CROATIAN",
			"cs" => "CZECH",
			"da" => "DANISH",
			"nl" => "DUTCH",
			"en" => "ENGLISH",
			"et" => "ESTONIAN",
			/*"tl" => "FILIPINO",*/
			"fi" => "FINNISH",
			"fr" => "FRENCH",
			"gl" => "GALICIAN",
			"de" => "GERMAN",
			"el" => "GREEK",
			"iw" => "HEBREW",
			"hi" => "HINDI",
			"hu" => "HUNGARIAN",
			"is" => "ICELANDIC",
			"id" => "INDONESIAN",
			"ga" => "IRISH",
			"it" => "ITALIAN",
			"ja" => "JAPANESE",
			"ko" => "KOREAN",
			"lv" => "LATVIAN",
			"lt" => "LITHUANIAN",
			"mk" => "MACEDONIAN",
			"ms" => "MALAY",
			"mt" => "MALTESE",
			"no" => "NORWEGIAN",
			"fa" => "PERSIAN",
			"pl" => "POLISH",
			"pt-PT" => "PORTUGUESE",
			"ro" => "ROMANIAN",
			"ru" => "RUSSIAN",
			"sr" => "SERBIAN",
			"sk" => "SLOVAK",
			"sl" => "SLOVENIAN",
			"es" => "SPANISH",
			"sw" => "SWAHILI",
			"sv" => "SWEDISH",
			"tl" => "TAGALOG",
			"th" => "THAI",
			"tr" => "TURKISH",
			"uk" => "UKRAINIAN",
			"vi" => "VIETNAMESE",
			"cy" => "WELSH",
			"yi" => "YIDDISH"
		);
		
		$plgParams = $this->plgParams;		
		$this->lang_position = $plgParams->get('lang_position', 'after');
		$this->lang_width = $plgParams->get('lang_width', 260);
		$this->lang_columns = $plgParams->get('lang_columns', 2);
		$this->link_style = $plgParams->get('link_style', 'icon');
		
		$languages = $plgParams->get('translate-specific-languages', '');
		$translate = $plgParams->get('translate', 'all');
		$exception = $plgParams->get('exception', '');
		
		$aLanguages = array();
		
		if($translate == 'all') {
			foreach($this->aLangSupport as $code => $langName) {
				$aLanguages[] = $code;
			}
		} elseif (is_array($languages)){
			$aLanguages = $languages;
		} elseif ($languages != '') {
			$aLanguages[] = $languages;
		} 
		$this->aLangSelect = $aLanguages;
		
		//block language
		$this->blockLang = $this->loadLayout ($this->plugin, 'languages');
		
		$this->aException = explode(',', $exception);		
	}
	

	function onContentAfterDisplay( $context, &$article, &$params, $limitstart )
	{
		global $option;
		static $count = 0;
		
		$this->countId = $count++;
		if ( JFactory::getApplication()->isAdmin() ) { return; }
		//$sectionid      = $article->sectionid;
		$catid          = $article->catid;
		$option 		= JRequest::getCmd('option');
		$view 			= JRequest::getCmd('view');
		$layout			= JRequest::getCmd('layout');
		$itemid 		= JRequest::getInt('Itemid');
		
		$plgParams = $this->plgParams;
		$categories        = $plgParams->get('categories', '');
		$only_detail_page  = (int) $plgParams->get('only_detail_page', 0);
		$translate_frontpage  = (int) $plgParams->get('translate_frontpage', 0);
		
		if($itemid != '' && $itemid != 0 && in_array($itemid, $this->aException)) {
			return;
		}
		if(count($this->aLangSelect) == 0) {
			return;
		}
		if($only_detail_page && $view != 'article') {
			return;
		}
		if($view == 'section' && !$layout) {
			return;
		}
		if($view == 'featured' && !$translate_frontpage) {
			return;
		}
		
		$aCategories = array();
		if (is_array($categories)){
			$aCategories = $categories;
		} elseif ($categories==''){
			$aCategories[] = $catid;
		} else {
			$aCategories[] = $categories;
		}
		
		if(!in_array($catid, $aCategories))
			return ;
	
		$block_language = str_replace('{block_id}', $this->countId, $this->blockLang);
		$block_language = str_replace('{title}', $article->title, $block_language);
		
		$output = $this->loadLayout ($this->plugin, 'default');
		if(isset($article->text)){
			$output = str_replace('{content}', $article->text, $output);
		}else{
			$output = str_replace('{content}', $article->introtext, $output);
		}
		$output = str_replace('{block_language}', $block_language, $output);

		if(isset($article->text)){
			$article->text = $output;
		}else{
			$article->introtext = $output;
		}
	}
	
	function onAfterRender() {
		
		global $option;
		
		if (JFactory::getApplication()->isAdmin ()) {
			return;
		}
		$body = JResponse::getBody ();
		
		preg_match('/ja\-translate\-wrapper/i', $body, $matches, PREG_OFFSET_CAPTURE);
		
		if(count($matches) > 0) {
			
			$body = $this->stylesheet ($this->plugin, $body);
			
			JResponse::setBody ( $body );
		}
		
	}
	
	
	function getLayoutPath($plugin, $layout = 'default')
	{	
		// Build the template and base path for the layout
		$tPath = JPATH_BASE.DS.'templates'.DS.JFactory::getApplication()->getTemplate().DS.'html'.DS.$plugin->name.DS.$layout.'.php';
		$bPath = JPATH_BASE.DS.'plugins'.DS.$plugin->type.DS.$plugin->name.DS.'tmpl'.DS.$layout.'.php';
		
		
		// If the template has a layout override use it
		if (file_exists($tPath)) {
			return $tPath;
			
		} elseif (file_exists($bPath)) {
	
			return $bPath;
			
		}
		return '';
	}

	function loadLayout ($plugin, $layout = 'default') {
		
		$layout_path = $this->getLayoutPath ($plugin, $layout);
		if ($layout_path) {
			ob_start();
			require $layout_path;
			$content = ob_get_contents();
			ob_end_clean();
			return $content;
		}
		return '';
	}

	function stylesheet ($plugin, $bodyString) {
		
		//$params = new JParameter ( $this->plugin->params );
		$params = new JRegistry;
		$params->loadJSON($this->plugin->params);
		
		$api_key = $params->get ( 'api_key', '' );
		$page_language = $params->get ( 'auto_detect-0-page_language', 'en' );
		$auto_detect = $params->get ( 'auto_detect', 1 );
		
		$auto_detect = intval($auto_detect);
		
		//
		$assets_url = JURI::base () . 'plugins/' . $plugin->type . '/' . $plugin->name . '/';
		
		$headtag = array ();
		$headtag [] = '<link href="' . $assets_url . 'assets/style.css" type="text/css" rel="stylesheet" />';
		
		$headtag [] = '<script src="http://www.google.com/jsapi?key=' . $api_key .'" type="text/javascript" ></script>';
		$headtag [] = '<script src="' . $assets_url . 'assets/script.js" type="text/javascript" ></script>';

		$headtag [] = "
		<script type=\"text/javascript\" >
			oJaTranslate = new JAGoogleTranslate('".$page_language."', ".$auto_detect.");
		</script>";
		
		$bodyString = str_replace ( '</head>', "\t" . implode ( "\n", $headtag ) . "\n</head>", $bodyString );
		
		$bodyString = str_replace ( '</body>', "\t<div id=\"ja-translate-popup\" style=\"display:none;\"></div>\n</body>\n", $bodyString );
		return $bodyString;
	} 
}
?>