<?php
/*
# ------------------------------------------------------------------------
# JA Translate for joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/ 

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

//Refer: http://code.google.com/apis/ajaxlanguage/documentation/

class plgContentPlg_JATranslate extends JPlugin
{
	var $countId = 0;
	var $aLangSelect = array();
	var $aException = array();
	var $blockLang = '';
	
	function plgContentPlg_JATranslate( &$subject, $config )
	{
		global $mainframe;
		parent::__construct( $subject, $config );
		
		if ( $mainframe->isAdmin() ) { 
			return; 
		}

		$this->plugin = &JPluginHelper::getPlugin('content', 'plg_jatranslate');
		$this->plgParams = new JParameter($this->plugin->params);
		$this->plgUrl = JURI::Root(true) . '/plugins/'.$this->plugin->type.'/'.$this->plugin->name.'/';
		
		$this->aLangSupport = array(
			"af" => "AFRIKAANS",
			"sq" => "ALBANIAN",
			"ar" => "ARABIC",
			"be" => "BELARUSIAN",
			"bg" => "BULGARIAN",
			"ca" => "CATALAN",
			"zh" => "CHINESE",
			"zh-CN" => "CHINESE SIMPLIFIED",
			"zh-TW" => "CHINESE TRADITIONAL",
			"hr" => "CROATIAN",
			"cs" => "CZECH",
			"da" => "DANISH",
			"nl" => "DUTCH",
			"en" => "ENGLISH",
			"et" => "ESTONIAN",
			/*"tl" => "FILIPINO",*/
			"fi" => "FINNISH",
			"fr" => "FRENCH",
			"gl" => "GALICIAN",
			"de" => "GERMAN",
			"el" => "GREEK",
			"iw" => "HEBREW",
			"hi" => "HINDI",
			"ht" => "HAITIAN CREOLE",
			"hu" => "HUNGARIAN",
			"is" => "ICELANDIC",
			"id" => "INDONESIAN",
			"ga" => "IRISH",
			"it" => "ITALIAN",
			"ja" => "JAPANESE",
			"ko" => "KOREAN",
			"lv" => "LATVIAN",
			"lt" => "LITHUANIAN",
			"mk" => "MACEDONIAN",
			"ms" => "MALAY",
			"mt" => "MALTESE",
			"no" => "NORWEGIAN",
			"fa" => "PERSIAN",
			"pl" => "POLISH",
			"pt-PT" => "PORTUGUESE",
			"ro" => "ROMANIAN",
			"ru" => "RUSSIAN",
			"sr" => "SERBIAN",
			"sk" => "SLOVAK",
			"sl" => "SLOVENIAN",
			"es" => "SPANISH",
			"sw" => "SWAHILI",
			"sv" => "SWEDISH",
			"tl" => "TAGALOG",
			"th" => "THAI",
			"tr" => "TURKISH",
			"uk" => "UKRAINIAN",
			"vi" => "VIETNAMESE",
			"cy" => "WELSH",
			"yi" => "YIDDISH"
		);
		
		$plgParams = $this->plgParams;		
		$this->lang_position = $plgParams->get('lang_position', 'after');
		$this->lang_width = $plgParams->get('lang_width', 260);
		$this->lang_columns = $plgParams->get('lang_columns', 2);
		$this->link_style = $plgParams->get('link_style', 'icon');
		$this->page_language = $plgParams->get ( 'auto_detect-0-page_language', 'en' );
		$this->auto_detect = (int) $plgParams->get ( 'auto_detect', 1 );
		
		$languages = $plgParams->get('translate-specific-languages', '');
		$translate = $plgParams->get('translate', 'all');
		$exception = $plgParams->get('exception', '');
		
		$aLanguages = array();
		
		if($translate == 'all') {
			foreach($this->aLangSupport as $code => $langName) {
				$aLanguages[] = $code;
			}
		} elseif (is_array($languages)){
			$aLanguages = $languages;
		} elseif ($languages != '') {
			$aLanguages[] = $languages;
		} 
		$this->aLangSelect = $aLanguages;
		
		//block language
		$this->blockLang = $this->loadLayout ($this->plugin, 'languages');
		
		$this->aException = explode(',', $exception);
		
		$this->stylesheet($this->plugin);
	}
	

	function onAfterDisplayContent( &$article, &$params, $limitstart )
	{
		global $mainframe;
		global $option;
		static $count = 0;
		
		$this->countId = $count++;
		if ( $mainframe->isAdmin() ) { return; }
		
		$sectionid      = $article->sectionid;
		$catid          = $article->catid;
		$option 		= JRequest::getCmd('option');
		$view 			= JRequest::getCmd('view');
		$layout			= JRequest::getCmd('layout');
		$itemid 		= JRequest::getInt('Itemid');
		$id				= JRequest::getInt('id');
		
		$plgParams = $this->plgParams;
		$categories        = $plgParams->get('categories', '');
		$only_detail_page  = (int) $plgParams->get('only_detail_page', 0);
		$translate_category  = (int) $plgParams->get('translate_category', 1);
		$translate_frontpage  = (int) $plgParams->get('translate_frontpage', 0);
		
		//no languages are selected
		if(count($this->aLangSelect) == 0) {
			return;
		}
		
		//in exclude list
		if(in_array($article->id, $this->aException)) {
			return;
		}
		//dont translating articles on front-page
		if($view == 'frontpage' && !$translate_frontpage) {
			return;
		}
		//dont translating articles on category page and section page
		if($view != 'article' && $view != 'frontpage' && !$translate_category) {
			return;
		}
		
		if($view == 'article') {
			if ($article->id != $id && !$translate_category) {
				return ;
			}
		}
		
		$aCategories = array();
		if (is_array($categories)){
			$aCategories = $categories;
		} elseif ($categories==''){
			$aCategories[] = $catid;
		} else {
			$aCategories[] = $categories;
		}
		
		if(!in_array($catid, $aCategories))
			return ;
		
		$block_language = str_replace('{block_id}', $this->countId, $this->blockLang);
		$block_language = str_replace('{title}', $article->title, $block_language);
		//
		$output = $this->loadLayout ($this->plugin, 'default');
		$output = str_replace('{content}', $article->text, $output);
		$output = str_replace('{block_language}', $block_language, $output);
		
		$article->text = $output;
	}
	
	
	function getLayoutPath($plugin, $layout = 'default')
	{
		global $mainframe;

		// Build the template and base path for the layout
		$tPath = JPATH_BASE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.$plugin->name.DS.$layout.'.php';
		$bPath = JPATH_BASE.DS.'plugins'.DS.$plugin->type.DS.$plugin->name.DS.'tmpl'.DS.$layout.'.php';
		// If the template has a layout override use it
		if (file_exists($tPath)) {
			return $tPath;
		} elseif (file_exists($bPath)) {
			return $bPath;
		}
		return '';
	}

	function loadLayout ($plugin, $layout = 'default') {
		$layout_path = $this->getLayoutPath ($plugin, $layout);
		if ($layout_path) {
			ob_start();
			require $layout_path;
			$content = ob_get_contents();
			ob_end_clean();
			return $content;
		}
		return '';
	}

	function stylesheet ($plugin) {
		global $mainframe;
		$params = new JParameter ( $this->plugin->params );
		
		$api_key = $params->get ( 'api_key', '' );
		//
		$assets_url = JURI::base () . 'plugins/' . $plugin->type . '/' . $plugin->name . '/';
		
		//css
		JHTML::stylesheet('style.css', $assets_url);
		if (is_file(JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'css'.DS.$plugin->name.".css"))
		JHTML::stylesheet($plugin->name.".css",'templates/'.$mainframe->getTemplate().'/css/');
		//script
		JHTML::script('', 'http://www.google.com/jsapi?key=' . $api_key);
		JHTML::script('script.js', $assets_url);
		
	} 
}
?>